#include "Mark.h"
#define CANT_INTER 20
#define MILSEG_REV 500 //min >= 300
#define TICS_PER_REV 100

Mark::Mark(){
	bool inverted = 0;
	unsigned long lastTime;
	bool limite = false;
	volatile int interB = 0;
	volatile int interA = 0;
	unsigned long lastTimeA = 0;
	int speedA = 100;
	int signalsA = 0;
	unsigned long lastTimeB = 0;
	int speedB = 100;
	int signalsB = 0;
  unsigned long desiredTime = CANT_INTER * MILSEG_REV / 900;
  int dirA = 1;
  int dirB = 1;
  float arc;
  float rad;
  int velDiffA[2] = {0, 0};
  int velDiffB[2] = {0, 0};
  int speed = 0;
  bool usingEncoder = false;
  double millisecondsPerTic = 0;
}

int Mark::getTime(){
	return (int)((millis()-lastTime)/1000);
}

void Mark::restartTime(){
	lastTime = millis();
}

bool Mark::isWhite(int pin, bool color){
	return (analogRead(pin)<512) == color;
}

void Mark::moveMotor(bool motor, bool dir, int rpm){
   if (rpm == 0){
    int motorPin = (motor)? 5: 11;
    analogWrite(motorPin,0);
    return;
  }
  if (rpm < 0){
    dir = !dir;
    rpm = rpm*-1;
  }
  rpm = min(rpm, 255);
  if(inverted){
    dir = !dir;
  }
  millisecondsPerTic = 1000.0f / ((rpm/60.0f)*TICS_PER_REV);
  speed = map(rpm, 0, 150, 0, 255);
  usingEncoder = false;
	if(inverted){
		dir = !dir;
	}
	if(!motor){
		digitalWrite(13,dir);
		analogWrite(11,speed);
	}else{
		digitalWrite(12,dir);
		analogWrite(5,speed);
	}
}

void Mark::move(bool dir, int rpm){
  if (rpm == 0){
    analogWrite(11,0);
	  analogWrite(5,0);
    usingEncoder = false;
    return;
  }
  if (rpm < 0){
    dir = !dir;
    rpm = rpm*-1;
  }
  rpm = map(rpm, 0, 100, 0, 150);
  rpm = min(rpm, 255);
	if(inverted){
		dir = !dir;
	}
  dirA = dir;
  dirB = !dir;
  millisecondsPerTic = 1000.0f / ((rpm/60.0f)*TICS_PER_REV);
  speed = map(rpm, 0, 150, 0, 255);
	digitalWrite(13,dirA);
	digitalWrite(12,dirB);
	analogWrite(11,min(255, speed  + velDiffA[dirA]));
	analogWrite(5,min(255, speed  + velDiffB[dirB]));
  usingEncoder = true;
  //lastTimeB = lastTimeA = millis();
}
void Mark::move(bool dir, int speed, float cm){
  interA = cm*100/22;
  interB = cm*100/22; 
  //int vel = map(speed, 0, 100, 0, 255);
  move(dir, speed);
  while (interA > 0 || interB > 0);
  move(0,0);
}

void Mark::twist(bool dir, int rpm){
  usingEncoder = false;
  if (rpm < 0){
    dir = !dir;
    rpm = rpm*-1;
  }
  rpm = min(rpm, 255);
  if(inverted){
    dir = !dir;
  }
  if(rpm!=0){
    int milisec = 60000/rpm;
    desiredTime = CANT_INTER * milisec / 900;
  }
  speedA = speedB = map(rpm, 0, 100, 0, 255);//min(255, rpm*255/90);
  dirA = dir;
  dirB = dir;
	digitalWrite(13,dir);
	digitalWrite(12,dir);
	analogWrite(11,speedA);
	analogWrite(5,speedB);
}

void Mark::twist(int dir, int vel, int grados, float distanciaRuedas) {
  //perim=22 cm
  float rad = (float)(grados) * 1000.0f / 57296.2957795f; 
  float arc = rad*(distanciaRuedas/2.0f);
  interA = (arc*100/22);
  interB = (arc*100/22);
  twist(dir, vel);
  while (interA > 0 || interB > 0);
  move(0,0);
}

void Mark::doEncoderA() {
  if(interA > 0)
    interA--;
  if (usingEncoder){
    if (millis() - lastTimeA > millisecondsPerTic){
      velDiffA[dirA]++;
    }else {
      velDiffA[dirA]--;
    }
	digitalWrite(13, dirA);
	  analogWrite(11,min(255, speed  + velDiffA[dirA]));
  }
  lastTimeA = millis();
}

void Mark::doEncoderB() {
  if (interB > 0)
    interB--;
  if (usingEncoder){
    if (millis() - lastTimeB > millisecondsPerTic){
      velDiffB[dirB]++;
    }else {
      velDiffB[dirB]--;
    }
	digitalWrite(12, dirB);
	analogWrite(5, min(255, speed  + velDiffB[dirB]));
  }
  lastTimeB = millis();
}